
/* Internetové rádio AURUINO UNO ( nebo kompatibilní ) s VS 1053B Shield ( nebo kompatibilní ) a Ethernet Shield W5100 R3
*  Dotykový displej NEXTION.
*  Autor :  David Kohout 03 / 2021
*/

//   Standartní knihovny
#include <VS1053.h>             // Standartní knihovna VS1053  ( Funguje i pod naším Shieldem, originál knihovnu SFEMP3Shield nepožívat,                        
#include <Ethernet.h>           // Standartní knihovna Ethernet - Shield W5100

// SPI porty ARDUINA MEGA

// 50 - MISO           Při použití ARDUINO MEGA proklemovat 50 Arduino na 12 pin zvukovky
// 51 - MOSI           Při použití ARDUINO MEGA proklemovat 51 Arduino na 11 pin zvukovky
// 52 - SCK            Při použití ARDUINO MEGA proklemovat 52 Arduino na 13 pin zvukovky

// ---------  Nemusí se ohýbat nožičky ze Shieldu, prostě natvrdo dát klemu -----------

VS1053 MP3player(6,7,2,8);  // X_CS 6 pin, X_DCS 7 pin, DREQ 2 pin, X_RESET 8 pin

byte mac[] = {0xDE, 0xDD, 0xBE, 0xBF, 0xFE, 0xED}; // Přiřazení MAC adresy síťovce - možno změnit

EthernetClient client;  // Ethernet jako klient
  
//--------------------------------------------------------------------------------------------------------//
uint8_t mp3buff[32];       // Velikost bufferu 32 Byte
const char *host;          // Zde se uloží adresa serveru s požadovaným streamem
const char *path;          // Zde se uloží cesta serveru s požadovaným streamem
int httpPort;              // Zde se uloží port serveru s požadovaným streamem
int ID_stanice=3;          // Zde se uloží číslo aktuálně přehrávané stanice - konstanta číslo stanice, které začne hrát po spuštění Arduina 
int pamet_ID_stanice;      // Zde se uloží číslo posledně přehrávané stanice
int Volume=10;             // Výchozí hlasitost rádia po zapnutí
int Prodleva=0;            // Prodleva odeslání dat na sériový port



void setup() {
   
Serial.begin(9600);           // Start sériové komunikace o rychlosti 9 600 B 
Ethernet.begin(mac);          // Start Ethernetového spojení, IP adresu přiřadí router
MP3player.begin();            // Start zvukové karty VS1053B Shield
MP3player.setVolume(Volume);  // Nižší číslo vyšší hlasitost

    
    client.print(String("GET ") + path + " HTTP/1.1\r\n" +  // Adresa serveru se streamem - požadavek při spuštění Arduina
                  "Host: " + host + "\r\n" + 
                  "Connection: close\r\n\r\n");
                  
}


void loop() {            // Hlavní program - smyčka

  if(Serial.available()) {        // Pokud je COM dostupný
    String Data_z_displeje="";    // Data jako znaky do proměnné Data_z_displeje
    delay(100);                   // Vyčkej 100 ms
  while(Serial.available()) {     // Jinak pokud je COM dostupný
    Data_z_displeje +=char(Serial.read()); // Přidej další znak ( y )
    }
      Zpracuj_data (Data_z_displeje); // Zavolej funkci
   }
   
Prodleva=Prodleva+1;  // Připočti číslo 1 do proměnné Prodleva ( číslo 500 odešle data na NEXTION )
                                                                                                                  
switch(ID_stanice){   // Přepínání stanic - ID stanice.Proměnná nazev zrušena - nyní zbytečná
        case 1:
           //nazev = " Hitradio 80 CZ";       
             host = "ice.abradio.cz";         // Hitrádio 80
             path = "/hit80128.mp3";
             httpPort = 80;
            break;
        case 2:
           //nazev = " Hitradio 90 CZ"; 
           host= "ice.abradio.cz";         // Hitrádio 90
           path = "/hit90128.mp3";
           httpPort = 80;
            break;
        case 3:
            //nazev = " Star*Sat Radio"; 
            host = "starsat-ais-edge-3004-fra-eco-cdn.cast.addradio.de";       // DE STAR*SAT RADIO
            path = "/starsat/live/mp3/low/stream.mp3";
            httpPort = 80;
            break;
        case 4:
            //nazev = "Antene Bayern 80"; 
            host = "s4-webradio.antenne.de";       // DE Antenne Bayern - 80er Hits
            path = "/80er-kulthits/stream/mp3";
            httpPort = 80;
            break;
        case 5:
            //nazev = "Antene Bayern 90"; 
            host = "s4-webradio.antenne.de";       // DE Antenne Bayern - 90er Hits
            path = "/90er-hits/stream/mp3";
            httpPort = 80;
            break;
        case 6:
            //nazev = " Hitradio Orion";           // CZ Hitrádio Orion Morava
            host = "ice.abradio.cz";
            path = "/orionmorava128.mp3";
            httpPort = 8000;
            break;
        case 7:
            //nazev = "   Radio CiTy";             // Radio CiTy
            host = "icecast.radiosity.sk";
            path = "/hq.mp3";
            httpPort = 8000;
            break;
        case 8:
            //nazev = " Athens Party GR";    // GR Athens Party
            host = "ice.onestreaming.com";
            path = "/athensparty";
            httpPort =80;
            break;
        case 9:
            //nazev = "Evropa 2 Top 40";      // CZ Evropa 2 Top 40
            host = "ice.actve.net";
            path = "/web-e2-top40";
            httpPort =80;
            break;
        case 10:
            //nazev = "   KISS 98 FM";      // CZ Kiss 98 FM
            host = "icecast4.play.cz";
            path = "/kiss128.mp3";
            httpPort =80;
            break; 
        case 11:
            //nazev = "90s Dance Party"; 
            host = "feierfreund.hoerradar.de";       // 90er Dance-Party von Feierfreund
            path = "/feierfreund-dance-mp3-mq";
            httpPort =80;
            break;

         case 12:
            //nazev = "Monte Carlo 98.2";    // Monako RMC 98.2
            host = "radiomonaco.ice.infomaniak.ch";
            path = "/radiomonaco-128.mp3";
            httpPort =80;
            break;

         case 13:
            //nazev = "Hitradio RT 1 - Dance";    // Hitradio RT 1 - Dance
            host = "rt1-ais-edge-3001-fra-eco-cdn.cast.addradio.de";
            path = "/rt1/eurodance/mp3/high/stream.mp3?";
            httpPort =80;
            break;

         case 14:
            //nazev = "CRO 1 Radiozurnal";    // ČRO 1 Radiožurnál
            host = "icecast7.play.cz";
            path = "/cro1-128.mp3";
            httpPort =8000;
            break;

         case 15:
            //nazev = "Hitradio Faktor";    // Hitrádio Faktor
            host = "ice.abradio.cz";
            path = "/faktor128.mp3";
            httpPort =8000;
            break; 

         case 16:
            //nazev = "Čas Rock Rádio";    // Čas Rock Rádio
            host = "icecast7.play.cz";
            path = "/casrock128.mp3";
            httpPort =80;
            break; 

         case 17:
            //nazev = "Rock Max";            // Rock Max
            host = "212.111.2.151";
            path = "/rockmax_128.mp3";
            httpPort =8000;
            break;

         case 18:
            //nazev = "Rock Radio Gold";     // Rock Radio Gold
            host = "ice.abradio.cz";
            path = "/gold128.mp3";
            httpPort =8000;
            break;

         case 19:
            //nazev = "Rock Metalománie";     // Rock Metalománie
            host = "ice.abradio.cz";
            path = "/metalomanie128.mp3";
            httpPort =80;
            break;

         case 20:
            //nazev = "Antenne Bayern - Top 40";     // Antenne Bayern - Top 40
            host = "s4-webradio.antenne.de";
            path = "/top-40/stream/mp3";
            httpPort =80;
            break;

         case 21:
            //nazev = "Antenne Bayern - Fresh Hits";     // Antenne Bayern - Fresh Hits
            host = "s4-webradio.antenne.de";
            path = "/fresh/stream/mp3";
            httpPort =80;
            break;

         case 22:
            //nazev = "Antenne Bayern - Love Songs";      // Antenne Bayern - Love Songs
            host = "s4-webradio.antenne.de";
            path = "/lovesongs/stream/mp3";
            httpPort =80;
            break; 
            
         case 23:
            //nazev = "Aktina 104,7 FM Corfu";    // GR Aktina 104,7 FM Corfu
            host = "live.e-streaming.eu";
            path = "/";
            httpPort =8110;
            break;

         case 24:
            //nazev = "Kiss Publikum CZ";    // CZ Kiss Publikum
            host = "icecast5.play.cz";
            path = "/expres128mp3";
            httpPort =8000;
            break;

          case 25:
             //nazev = "SeeJay CZ";          // CZ SeeJay
             host = "mp3stream.abradio.cz";       
             path = "/seejay128.mp3";
             httpPort = 8000;
             break;

         case 26:
            //nazev = "Antenne Bayern 2000 er Hits";       // Antenne Bayern 2000 er Hits
            host = "s3-webradio.antenne.de";       
            path = "/2000er-hits/stream/mp3";
            httpPort = 80;;
            break;

         case 27:
            //nazev = "FUN radio SK";      // Fun rádio SK
            host = "stream.funradio.sk";     
            path = "/dance128.mp3";
            httpPort = 8000;
            break;

         case 28:
            //nazev = "Radio Zlin Best Ballads";      // CZ Rádio Zlín Best Ballads
            host = "212.111.2.151";
            path = "/radiozlin_128.mp3";
            httpPort =8000;
            break;

         case 29:
            //nazev = "N-Joy Radio Bulgaria";      // BG N-Joy Radio
            host = "live.btvradio.bg";
            path = "/njoy.mp3";
            httpPort =80;
            break;

         case 30:
            //nazev = "Antenne Bayern Classic Rock";      // Antenne Bayern Classic Rock
            host = "s5-webradio.antenne.de";
            path = "/classic-rock-live/stream/mp3";
            httpPort =80;
            break;               
    }

    if(!client.connected() || pamet_ID_stanice!=ID_stanice){    
    
      if(client.connect(host, httpPort)){                // Adresa serveru se streamem - ve smyčce
       client.print(String("GET ") + path + " HTTP/1.1\r\n" +
                  "Host: " + host + "\r\n" + 
                  "Connection: close\r\n\r\n");
                   pamet_ID_stanice=ID_stanice;          // Paměť předcházející stanice
      }
     }
  
    if(client.available() > 0){                                          // Pokud je server dostupný, tak :
      uint8_t bytesread = client.read(mp3buff,32);                       // ulož přijatá data do bufferu
    MP3player.playChunk(mp3buff,bytesread);                              // a přehraj na VS1053B Shield
   } 
    if (Prodleva >= 500){              // Když byly data odeslána na VS 1053B po 500 cyklech, tak :
       
  Posli_data();                        // Zavolej funkci poslání dat na serial COM ( Nextion )
}
}

void Posli_data(){      // Funkce posílání dat na displej Nextion
  Prodleva=0;           // Vynuluj proměnnou Prodleva - počítej zase od 0
  String command="ID.txt=\""+String(ID_stanice)+"\""; // Sestavení řetězce znaků k odeslání
  Serial.print(command);  // Odešli řetězec s jménem command do textového pole se jménem ID v NEXTION
  Serial.write(0xff);     // Tyto tři řádky musíme vždy odeslat po každém odeslaném příkazu na NEXTION displej
  Serial.write(0xff);     // Tyto tři řádky musíme vždy odeslat po každém odeslaném příkazu na NEXTION displej
  Serial.write(0xff);     // Tyto tři řádky musíme vždy odeslat po každém odeslaném příkazu na NEXTION displej
}

 void Zpracuj_data(String Data_z_displeje){ // Funkce zpracování dat z displeje NEXTION


  if ((Data_z_displeje =="CHM") && (ID_stanice >1)){ // Jsou-li přijaty znaky CHM a aktuální stanice je větší jak 1,         
    ID_stanice=ID_stanice -1;                        // tak aktuální stanice bude o 1 menší
    }

    if ((Data_z_displeje =="CHP")&& (ID_stanice <30)){ // Jsou-li přijaty znaky CHP a aktuální stanice je menší jak 30,
    ID_stanice=ID_stanice +1;                          // tak aktuální stanice bude o 1 větší
}

if ((Data_z_displeje =="VOLP")&& (Volume >5)){         // Jsou-li přijaty znaky VOLP a aktuální hlasitost je větší jak 5,
    Volume=Volume -5;                                  // tak aktuální hlasitost bude o 5 menší
    MP3player.setVolume(Volume);                       // NIŽŠÍ ČÍSLO = VYŠŠÍ HLASITOST - chyba knihovny
}

if ((Data_z_displeje =="VOLM")&& (Volume <95)){        // Jsou-li přijaty znaky VOLM a aktuální hlasitost je menší jak 95,
    Volume=Volume +5;                                  // tak aktuální hlasitost bude o 5 větší
    MP3player.setVolume(Volume);                       // VYŠŠÍ ČÍSLO = NIŽŠÍ HLASITOST - chyba knihovny
}
}                            //  ---   Konec programu   ---  //

// To je vše, příjemnou zábavu !                 David Kohout 03 / 2021
